'use strict'
//компонент tmdlms
function tm_dlms_add()
{
var PG = new tm_plugin();
//--------------------------------------------------------------
var OBIS = {
    '' : { sn:'???', ln: '' }
//профили    
  , '1.0.99.1.0.255' : { sn:'нагр', ln: '1.0.99.1.0.255 профиль нагрузки', p:'p', c:'ABCD' }
  , '1.0.98.2.0.255' : { sn:'сут', ln: '1.0.98.2.0.255 профиль за сутки', p:'d', c:'ABCD' }
  , '1.0.98.1.0.255' : { sn:'мес', ln: '1.0.98.1.0.255 профиль за месяц', p:'m', c:'ABCD' }
  , '1.0.94.7.0.255' : { sn:'мгн', ln: '1.0.94.7.0.255 профиль мгновенных параметров', p:'t', c:'ABCD' }
  , '1.0.94.7.5.255' : { sn:'ти', ln: '1.0.94.7.5.255 профиль телеизмерений', p:'i', c:'ABC' }
  , '1.0.94.7.6.255' : { sn:'тс', ln: '1.0.94.7.6.255 профиль телесигнализации', p:'s', c:'ABC' }
//мгновенные значения
  , '1.0.31.7.0.255' : { sn:'Ia', ln: '1.0.31.7.0.255 Ток фазы А', r:'ti', c:'ABC', cl:'obisI' }
  , '1.0.51.7.0.255' : { sn:'Ib', ln: '1.0.51.7.0.255 Ток фазы В', r:'ti', c:'ABC', cl:'obisI' }
  , '1.0.71.7.0.255' : { sn:'Ic', ln: '1.0.71.7.0.255 Ток фазы С', r:'ti', c:'ABC', cl:'obisI' }
  , '1.0.32.7.0.255' : { sn:'Ua/ab', ln: '1.0.32.7.0.255 Напряжение фазы А / AB линейное', r:'tpi', c:'ABC', cl:'obisU' }
  , '1.0.52.7.0.255' : { sn:'Ub/cb', ln: '1.0.52.7.0.255 Напряжение фазы B / CB линейное', r:'tpi', c:'ABC', cl:'obisU' }
  , '1.0.72.7.0.255' : { sn:'Uc/ac', ln: '1.0.72.7.0.255 Напряжение фазы C / AC линейное', r:'tpi', c:'ABC', cl:'obisU' }
  , '1.0.33.7.0.255' : { sn:'PFa', ln: '1.0.33.7.0.255 * Коэффициент мощности фазы А', r:'t', c:'ABC' }
  , '1.0.53.7.0.255' : { sn:'PFb', ln: '1.0.53.7.0.255 * Коэффициент мощности фазы B', r:'t', c:'ABC' }
  , '1.0.73.7.0.255' : { sn:'PFc', ln: '1.0.73.7.0.255 * Коэффициент мощности фазы C', r:'t', c:'ABC' }
  , '1.0.13.7.0.255' : { sn:'PF', ln: '1.0.13.7.0.255 Общий коэффициент мощности', r:'ti', c:'ABCD' }
  , '1.0.14.7.0.255' : { sn:'f', ln: '1.0.14.7.0.255 Частота сети', r:'t', c:'ABCD' }
  , '1.0.9.7.0.255' : { sn:'S', ln: '1.0.9.7.0.255 Полная мощность', r:'ti', c:'ABCD', cl:'obisS' }
  , '1.0.29.7.0.255' : { sn:'Sa', ln: '1.0.29.7.0.255 * Полная мощность фазы А', r:'t', c:'ABC', cl:'obisS' }
  , '1.0.49.7.0.255' : { sn:'Sb', ln: '1.0.49.7.0.255 * Полная мощность фазы B', r:'t', c:'ABC', cl:'obisS' }
  , '1.0.69.7.0.255' : { sn:'Sc', ln: '1.0.69.7.0.255 * Полная мощность фазы C', r:'t', c:'ABC', cl:'obisS' }
  , '1.0.1.7.0.255' : { sn:'P', ln: '1.0.1.7.0.255 Активная мощность', r:'ti', c:'ABCD', cl:'obisP' }
  , '1.0.21.7.0.255' : { sn:'Pa', ln: '1.0.21.7.0.255 * Активная мощность фазы А', r:'t', c:'ABC', cl:'obisP' }
  , '1.0.41.7.0.255' : { sn:'Pb', ln: '1.0.41.7.0.255 * Активная мощность фазы B', r:'t', c:'ABC', cl:'obisP' }
  , '1.0.61.7.0.255' : { sn:'Pc', ln: '1.0.61.7.0.255 * Активная мощность фазы C', r:'t', c:'ABC', cl:'obisP' }
  , '1.0.3.7.0.255' : { sn:'R', ln: '1.0.3.7.0.255 Реактивная мощность', r:'ti', c:'ABCD', cl:'obisR' }
  , '1.0.23.7.0.255' : { sn:'Ra', ln: '1.0.23.7.0.255 * Реактивная мощность фазы А', r:'t', c:'ABC', cl:'obisR' }
  , '1.0.43.7.0.255' : { sn:'Rb', ln: '1.0.43.7.0.255 * Реактивная мощность фазы B', r:'t', c:'ABC', cl:'obisR' }
  , '1.0.63.7.0.255' : { sn:'Rc', ln: '1.0.63.7.0.255 * Реактивная мощность фазы C', r:'t', c:'ABC', cl:'obisR' }
  , '1.0.1.8.0.255' : { sn:'E+', ln: '1.0.1.8.0.255 Активная энергия, импорт', r:'tdm', c:'ABCD', cl:'obisEi' }
  , '1.0.2.8.0.255' : { sn:'E-', ln: '1.0.2.8.0.255 Активная энергия, экспорт', r:'tdm', c:'ABCD', cl:'obisEe' }
  , '1.0.3.8.0.255' : { sn:'W+', ln: '1.0.3.8.0.255 Реактивная энергия, импорт', r:'tdm', c:'ABCD', cl:'obisWi' }
  , '1.0.4.8.0.255' : { sn:'W-', ln: '1.0.4.8.0.255 Реактивная энергия, экспорт', r:'tdm', c:'ABCD', cl:'obisWe' }
  , '1.0.88.8.0.255' : { sn:'Hi', ln: '1.0.88.8.0.255 * Удельная энергия потерь в цепях тока', r:'tdm', c:'ABCD' }
  , '1.0.89.8.0.255' : { sn:'Ht', ln: '1.0.89.8.0.255 * Удельная энергия потерь в силовых трансформаторах', r:'tdm', c:'ABC' }
  , '1.0.12.7.1.255' : { sn:'uAB', ln: '1.0.12.7.1.255 * Межфазное напряжение АВ', r:'t', c:'ABC', cl:'obisU' }
  , '1.0.12.7.2.255' : { sn:'uBC', ln: '1.0.12.7.2.255 * Межфазное напряжение ВС', r:'t', c:'ABC', cl:'obisU' }
  , '1.0.12.7.3.255' : { sn:'uAC', ln: '1.0.12.7.3.255 * Межфазное напряжение АС', r:'t', c:'ABC', cl:'obisU' }
  , '1.0.15.16.0.255' : { sn:'', ln: '1.0.15.16.0.255 * Суточное значение максимальной активной мощности интервале интегрирования', r:'td', c:'ABCD' }
  , '1.0.15.16.1.255' : { sn:'', ln: '1.0.15.16.1.255 * Суточное значение максимальной активной мощности на интервале интегрирования в период пиковых', r:'td', c:'ABCD' }
  , '1.0.21.8.0.255' : { sn:'', ln: '1.0.21.8.0.255 * Активная энергия фаза А. Импорт', r:'tdm', c:'ABC', cl:'obisEi' }
  , '1.0.41.8.0.255' : { sn:'', ln: '1.0.41.8.0.255 * Активная энергия фаза B. Импорт', r:'tdm', c:'ABC', cl:'obisEi' }
  , '1.0.61.8.0.255' : { sn:'', ln: '1.0.61.8.0.255 * Активная энергия фаза C. Импорт', r:'tdm', c:'ABC', cl:'obisEi' }
  , '1.0.22.8.0.255' : { sn:'', ln: '1.0.22.8.0.255 * Активная энергия фаза А. Экспорт', r:'tdm', c:'ABC', cl:'obisEe' }
  , '1.0.42.8.0.255' : { sn:'', ln: '1.0.42.8.0.255 * Активная энергия фаза B. Экспорт', r:'tdm', c:'ABC', cl:'obisEe' }
  , '1.0.62.8.0.255' : { sn:'', ln: '1.0.62.8.0.255 * Активная энергия фаза C. Экспорт', r:'tdm', c:'ABC', cl:'obisEe' }
  , '1.0.23.8.0.255' : { sn:'', ln: '1.0.23.8.0.255 * Реактивная энергия фаза А. Импорт', r:'tdm', c:'ABC', cl:'obisWi' }
  , '1.0.43.8.0.255' : { sn:'', ln: '1.0.43.8.0.255 * Реактивная энергия фаза B. Импорт', r:'tdm', c:'ABC', cl:'obisWi' }
  , '1.0.63.8.0.255' : { sn:'', ln: '1.0.63.8.0.255 * Реактивная энергия фаза C. Импорт', r:'tdm', c:'ABC', cl:'obisWi' }
  , '1.0.24.8.0.255' : { sn:'', ln: '1.0.24.8.0.255 * Реактивная энергия фаза А. Экспорт', r:'tdm', c:'ABC', cl:'obisWe' }
  , '1.0.44.8.0.255' : { sn:'', ln: '1.0.44.8.0.255 * Реактивная энергия фаза B. Экспорт', r:'tdm', c:'ABC', cl:'obisWe' }
  , '1.0.64.8.0.255' : { sn:'', ln: '1.0.64.8.0.255 * Реактивная энергия фаза C. Экспорт', r:'tdm', c:'ABC', cl:'obisWe' }
//регистры профиля
  , '1.0.1.29.0.255' : { sn:'bA+', ln: '1.0.1.29.0.255 импорт, активная энергия за период', r:'p', c:'ABCD', cl:'obisEi' }
  , '1.0.2.29.0.255' : { sn:'bA-', ln: '1.0.2.29.0.255 экспорт, активная энергия за период', r:'p', c:'ABCD', cl:'obisEe' }
  , '1.0.3.29.0.255' : { sn:'bR+', ln: '1.0.3.29.0.255 импорт, реактивная энергия за период', r:'p', c:'ABCD', cl:'obisWi' }
  , '1.0.4.29.0.255' : { sn:'bR-', ln: '1.0.4.29.0.255 экспорт, реактивная энергия за период', r:'p', c:'ABCD', cl:'obisWe' }
  , '0.0.96.9.0.255' : { sn:'t', ln: '0.0.96.9.0.255 * Температура, С°', r:'p', c:'ABCD' }
  , '0.0.96.8.0.255' : { sn:'T', ln: '0.0.96.8.0.255 * Время работы счетчика', r:'pdm', c:'ABCD' }
  , '1.0.1.8.1.255' : { sn:'cA+1', ln: '1.0.1.8.1.255 импорт, активная энергия, 1 тариф', r:'dm', c:'ABCD', cl:'obisEi' }
  , '1.0.1.8.2.255' : { sn:'cA+2', ln: '1.0.1.8.2.255 импорт, активная энергия, 2 тариф', r:'dm', c:'ABCD', cl:'obisEi' }
  , '1.0.1.8.3.255' : { sn:'cA+3', ln: '1.0.1.8.3.255 импорт, активная энергия, 3 тариф', r:'dm', c:'ABCD', cl:'obisEi' }
  , '1.0.1.8.4.255' : { sn:'cA+4', ln: '1.0.1.8.4.255 импорт, активная энергия, 4 тариф', r:'dm', c:'ABCD', cl:'obisEi' }
  , '1.0.1.8.5.255' : { sn:'cA+1', ln: '1.0.1.8.5.255 * импорт, активная энергия, 5 тариф', r:'dm', c:'ABCD', cl:'obisEi' }
  , '1.0.1.8.6.255' : { sn:'cA+2', ln: '1.0.1.8.6.255 * импорт, активная энергия, 6 тариф', r:'dm', c:'ABCD', cl:'obisEi' }
  , '1.0.1.8.7.255' : { sn:'cA+3', ln: '1.0.1.8.7.255 * импорт, активная энергия, 7 тариф', r:'dm', c:'ABCD', cl:'obisEi' }
  , '1.0.1.8.8.255' : { sn:'cA+4', ln: '1.0.1.8.8.255 * импорт, активная энергия, 8 тариф', r:'dm', c:'ABCD', cl:'obisEi' }
  , '0.0.96.8.1.255' : { sn:'', ln: '0.0.96.8.1.255 * Время некачественной частоты', r:'d', c:'ABCD' }
  , '0.0.96.5.1.255' : { sn:'', ln: '0.0.96.5.1.255 Статус некачественной энергии', r:'d', c:'ABCD' }
  , '1.0.2.8.1.255' : { sn:'', ln: '1.0.2.8.1.255 экспорт, активная энергия, 1 тариф ', r:'dm', c:'ABCD', cl:'obisEe' }
  , '1.0.2.8.2.255' : { sn:'', ln: '1.0.2.8.2.255 экспорт, активная энергия, 2 тариф', r:'dm', c:'ABCD', cl:'obisEe' }
  , '1.0.2.8.3.255' : { sn:'', ln: '1.0.2.8.3.255 экспорт, активная энергия, 3 тариф', r:'dm', c:'ABCD', cl:'obisEe' }
  , '1.0.2.8.4.255' : { sn:'', ln: '1.0.2.8.4.255 экспорт, активная энергия, 4 тариф', r:'dm', c:'ABCD', cl:'obisEe' }
  , '1.0.2.8.5.255' : { sn:'', ln: '1.0.2.8.5.255 экспорт, активная энергия, 5 тариф', r:'dm', c:'ABCD', cl:'obisEe' }
  , '1.0.2.8.6.255' : { sn:'', ln: '1.0.2.8.6.255 экспорт, активная энергия, 6 тариф', r:'dm', c:'ABCD', cl:'obisEe' }
  , '1.0.2.8.7.255' : { sn:'', ln: '1.0.2.8.7.255 экспорт, активная энергия, 7 тариф', r:'dm', c:'ABCD', cl:'obisEe' }
  , '1.0.2.8.8.255' : { sn:'', ln: '1.0.2.8.8.255 экспорт, активная энергия, 8 тариф', r:'dm', c:'ABCD', cl:'obisEe' }
  , '1.0.3.8.1.255' : { sn:'', ln: '1.0.3.8.1.255 импорт, реактивная энергия, 1 тариф', r:'dm', c:'ABCD', cl:'obisWi' }
  , '1.0.3.8.2.255' : { sn:'', ln: '1.0.3.8.2.255 импорт, реактивная энергия, 2 тариф', r:'dm', c:'ABCD', cl:'obisWi' }
  , '1.0.3.8.3.255' : { sn:'', ln: '1.0.3.8.3.255 импорт, реактивная энергия, 3 тариф', r:'dm', c:'ABCD', cl:'obisWi' }
  , '1.0.3.8.4.255' : { sn:'', ln: '1.0.3.8.4.255 импорт, реактивная энергия, 4 тариф', r:'dm', c:'ABCD', cl:'obisWi' }
  , '1.0.3.8.5.255' : { sn:'', ln: '1.0.3.8.5.255 импорт, реактивная энергия, 5 тариф', r:'dm', c:'ABCD', cl:'obisWi' }
  , '1.0.3.8.6.255' : { sn:'', ln: '1.0.3.8.6.255 импорт, реактивная энергия, 6 тариф', r:'dm', c:'ABCD', cl:'obisWi' }
  , '1.0.3.8.7.255' : { sn:'', ln: '1.0.3.8.7.255 импорт, реактивная энергия, 7 тариф', r:'dm', c:'ABCD', cl:'obisWi' }
  , '1.0.3.8.8.255' : { sn:'', ln: '1.0.3.8.8.255 импорт, реактивная энергия, 8 тариф', r:'dm', c:'ABCD', cl:'obisWi' }
  , '1.0.4.8.1.255' : { sn:'', ln: '1.0.4.8.1.255 экспорт, реактивная энергия, 1 тариф', r:'dm', c:'ABCD', cl:'obisWe' }
  , '1.0.4.8.2.255' : { sn:'', ln: '1.0.4.8.2.255 экспорт, реактивная энергия, 2 тариф', r:'dm', c:'ABCD', cl:'obisWe' }
  , '1.0.4.8.3.255' : { sn:'', ln: '1.0.4.8.3.255 экспорт, реактивная энергия, 3 тариф', r:'dm', c:'ABCD', cl:'obisWe' }
  , '1.0.4.8.4.255' : { sn:'', ln: '1.0.4.8.4.255 экспорт, реактивная энергия, 4 тариф', r:'dm', c:'ABCD', cl:'obisWe' }
  , '1.0.4.8.5.255' : { sn:'', ln: '1.0.4.8.5.255 экспорт, реактивная энергия, 5 тариф', r:'dm', c:'ABCD', cl:'obisWe' }
  , '1.0.4.8.6.255' : { sn:'', ln: '1.0.4.8.6.255 экспорт, реактивная энергия, 6 тариф', r:'dm', c:'ABCD', cl:'obisWe' }
  , '1.0.4.8.7.255' : { sn:'', ln: '1.0.4.8.7.255 экспорт, реактивная энергия, 7 тариф', r:'dm', c:'ABCD', cl:'obisWe' }
  , '1.0.4.8.8.255' : { sn:'', ln: '1.0.4.8.8.255 экспорт, реактивная энергия, 8 тариф', r:'dm', c:'ABCD', cl:'obisWe' }
  , '1.0.88.8.1.255' : { sn:'', ln: '1.0.88.8.1.255 энергия потерь в ЛЭП, 1 тариф', r:'dm', c:'ABCD' }
  , '1.0.88.8.2.255' : { sn:'', ln: '1.0.88.8.2.255 энергия потерь в ЛЭП, 2 тариф', r:'dm', c:'ABCD' }
  , '1.0.88.8.3.255' : { sn:'', ln: '1.0.88.8.3.255 энергия потерь в ЛЭП, 3 тариф', r:'dm', c:'ABCD' }
  , '1.0.88.8.4.255' : { sn:'', ln: '1.0.88.8.4.255 энергия потерь в ЛЭП, 4 тариф', r:'dm', c:'ABCD' }
  , '1.0.88.8.5.255' : { sn:'', ln: '1.0.88.8.5.255 энергия потерь в ЛЭП, 5 тариф', r:'dm', c:'ABCD' }
  , '1.0.88.8.6.255' : { sn:'', ln: '1.0.88.8.6.255 энергия потерь в ЛЭП, 6 тариф', r:'dm', c:'ABCD' }
  , '1.0.88.8.7.255' : { sn:'', ln: '1.0.88.8.7.255 энергия потерь в ЛЭП, 7 тариф', r:'dm', c:'ABCD' }
  , '1.0.88.8.8.255' : { sn:'', ln: '1.0.88.8.8.255 энергия потерь в ЛЭП, 8 тариф', r:'dm', c:'ABCD' }
  , '1.0.89.8.1.255' : { sn:'', ln: '1.0.89.8.1.255 энергия потерь в силовых трансформаторах, 1 тариф', r:'dm', c:'ABC' }
  , '1.0.89.8.2.255' : { sn:'', ln: '1.0.89.8.2.255 энергия потерь в силовых трансформаторах, 2 тариф', r:'dm', c:'ABC' }
  , '1.0.89.8.3.255' : { sn:'', ln: '1.0.89.8.3.255 энергия потерь в силовых трансформаторах, 3 тариф', r:'dm', c:'ABC' }
  , '1.0.89.8.4.255' : { sn:'', ln: '1.0.89.8.4.255 энергия потерь в силовых трансформаторах, 4 тариф', r:'dm', c:'ABC' }
  , '1.0.89.8.5.255' : { sn:'', ln: '1.0.89.8.5.255 энергия потерь в силовых трансформаторах, 5 тариф', r:'dm', c:'ABC' }
  , '1.0.89.8.6.255' : { sn:'', ln: '1.0.89.8.6.255 энергия потерь в силовых трансформаторах, 6 тариф', r:'dm', c:'ABC' }
  , '1.0.89.8.7.255' : { sn:'', ln: '1.0.89.8.7.255 энергия потерь в силовых трансформаторах, 7 тариф', r:'dm', c:'ABC' }
  , '1.0.89.8.8.255' : { sn:'', ln: '1.0.89.8.8.255 энергия потерь в силовых трансформаторах, 8 тариф', r:'dm', c:'ABC' }
  , '1.0.0.8.6.255' : { sn:'', ln: '1.0.0.8.6.255 Интервал интегрирования параметров сети', r:'dm', c:'ABCD' }
  , '1.0.9.8.0.255' : { sn:'', ln: '1.0.9.8.0.255 Полная энергия', r:'m', c:'ABC' }
  , '1.0.1.6.0.255' : { sn:'', ln: '1.0.1.6.0.255 Максимальная мощность за месяц и время пика мощности', r:'m', c:'ABCD' }
  , '1.0.131.6.128.255' : { sn:'', ln: '1.0.131.6.128.255 tg(φ) Максимальное значение на интервале интегрирования за расчетный период', r:'m', c:'ABCD' }
  , '1.0.9.3.128.255' : { sn:'', ln: '1.0.9.3.128.255 Минимальное значение полной мощности на интервале интегрирования за расчетный период', r:'m', c:'ABCD', cl:'obisS' }
  , '1.0.9.6.128.255' : { sn:'', ln: '1.0.9.6.128.255 Максимальное значение полной мощности на интервале интегрирования за расчетный период', r:'m', c:'ABCD', cl:'obisS' }
  , '1.0.15.3.128.255' : { sn:'', ln: '1.0.15.3.128.255 Минимальное значение активной мощности на интервале интегрирования за расчетный период', r:'m', c:'ABCD' }
  , '1.0.15.6.128.255' : { sn:'', ln: '1.0.15.6.128.255 Максимальное значение активной мощности на интервале интегрирования за расчетный период', r:'m', c:'ABCD' }
  , '1.0.137.3.128.255' : { sn:'', ln: '1.0.137.3.128.255 Минимальное значение реактивной мощности на интервале интегрирования ', r:'m', c:'ABCD' }
  , '1.0.137.6.128.255' : { sn:'', ln: '1.0.137.6.128.255 Максимальное значение реактивной мощности на интервале интегрирования за расчетный период', r:'m', c:'ABCD' }
  , '1.0.15.6.129.255' : { sn:'', ln: '1.0.15.6.129.255 Усредненное за месяц суточное значение максимальной активной мощности на интервале интегрирования', r:'m', c:'ABCD' }
  , '1.0.15.6.130.255' : { sn:'', ln: '1.0.15.6.130.255 Усредненное за месяц суточное значение максимальной активной мощности на интервале интегрирования в период пиковых нагрузок', r:'m', c:'ABCD' }
//класс D
  , '1.0.11.7.0.255' : { sn:'I', ln: '1.0.11.7.0.255 Ток фазы', r:'tp', c:'D', cl:'obisI' }
  , '1.0.91.7.0.255' : { sn:'In', ln: '1.0.91.7.0.255 Ток нулевого провода', r:'tp', c:'D', cl:'obisI' }
  , '1.0.12.7.0.255' : { sn:'V', ln: '1.0.12.7.0.255 Напряжение фазы', r:'tp', c:'D', cl:'obisU' }
  , '1.0.91.7.131.255' : { sn:'', ln: '1.0.91.7.131.255 Дифференциальный ток', r:'t', c:'D', cl:'obisI' }
  , '1.0.91.7.132.255' : { sn:'', ln: '1.0.91.7.132.255 Дифференциальный ток, % от величины наибольшего тока', r:'t', c:'D', cl:'obisI' }
  , '1.0.9.29.0.255' : { sn:'', ln: '1.0.9.29.0.255 Полная энергия за период записи', r:'p', c:'D', cl:'obisS' }
//  , '' : { sn:'', ln: ' ', r:'', c:'' }
//  , '' : { sn:'', ln: ' ', r:'m', c:'D' }
  };

var filrOBIS = function( ref )
{ //фильтр значений в списке
  var parent = ref.parentNode;
  while( true )
  {
    var parent = tree_item_parent( parent );
    if( ! parent || ! parent._REF )
     return this.VALs;
    if( parent._REF.tp == 'dlmscl_dev')
    { // категория счетчика
      var mcat = parent._REF.dlmscl_mcat;
      break;
    }
    if( parent._REF.tp == 'dlmscl_pg')
    { // OBIS профиля
      var pobis = parent._REF.dlmscl_pobis;
      var pvals = __PARs.dlmscl_pobis.VALs;
      var pvl = pvals[pobis];
    }
  }
  var vals = {};
  var VALs = this.VALs;
  switch( ref.tp )
  {
  case 'dlmscl_pnreg':
  {
    for( var v in VALs )
    {
      var vl = VALs[v];
      if( vl.r )
      if( vl.r.indexOf( pvl.p ) >= 0 )
      if( vl.c )
      if( vl.c.indexOf( mcat ) >= 0 )
        vals[v] = vl;
    }
    break;
  }
  case 'dlmscl_pg':
  { // для профиля
    for( var v in VALs )
    {
      var vl = VALs[v];
      if( vl.p )
      if( vl.c )
      if( vl.c.indexOf( mcat ) >= 0 )
        vals[v] = vl;
    }
    break;
  }
  case 'dlmscl_reg':
  { // для текущих значений
    for( var v in VALs )
    {
      var vl = VALs[v];
      if( vl.r )
      if( vl.r.indexOf( 't' ) >= 0 )
      if( vl.c )
      if( vl.c.indexOf( mcat ) >= 0 )
        vals[v] = vl;
    }
    break;
  }
  }
  return vals; 
}

var titleOBIS = function(val,tp,el)
 { 
   if( el )
     this.init( el, val );
   var c = this.VALs[val];
   if( c )
     if( val != c.sn )
       val = c.ln;
   return val;
 }
//DLMS клиент..
PG.add_comp( {nm:'dlmscl', parents:["port"]
, obj:{
  nm:'DLMS client', add:true, st:'', log:true
//  , add_tps:[]
, hint:'DLMS client'
  , pnm:{ nm:'', var_ok:'', tcpto:'0', log:'0', log_sz:'10', log_dd:'0', loglevel:'0'}
}} );
//--------------------------------------------------------------
//DLMS устройство..
PG.add_comp( {nm:'dlmscl_dev', parents:['dlmscl']
, obj:{
  nm:'DLMS device', add:true, st:''//, log:true
, hint:'DLMS device'
, im:'imMeter'
  , pnm:{ nm:'', var_ok:'', dlmscl_caddr:'32', dlmscl_paddr:'', dlmscl_laddr:'1', dlmscl_daddr:'', dlmscl_to:'', dlmscl_auth:'0', dlmscl_pass:'', dlmscl_sec:'0', dlmscl_syst:'', dlmscl_akey:'', dlmscl_ekey:'', dlmscl_dkey:'', dlmscl_itp:'0', dlmscl_mcat:'C', dlmscl_mtp:'', dlmscl_msn:''}
}} );
//..адрес клиента
PG.add_cpar( {nm:'dlmscl_caddr', obj:
{ ed:'q',ln:'Client address'//, tps:{ 'dlmscl_dev':'32'}
 , hint:'Client address.'
 , i_title:2
 , title: function(val,tp,el)
 {
   return val;
 }
 , VALs: {
    '16' : { sn:'16', ln: '16 - Public client' }
  , '32' : { sn:'32', ln: '32 - Counter reader' }
  , '48' : { sn:'48', ln: '48 - Configurator' }
  }
}});
//..физический адрес устройства
PG.add_cpar( {nm:'dlmscl_paddr', obj:
{ ed:'e',ln:'Physical address'//, tps:{ 'dlmscl_dev':''}
 , hint:'Physical address of the device.'
 , i_title:2
 , title: function(val,tp,el)
 {
   return val;
 }
}});
//..логический адрес устройства
PG.add_cpar( {nm:'dlmscl_laddr', obj:
{ ed:'e',ln:'Logical address'//, tps:{ 'dlmscl_dev':'1'}
 , hint:'Device logical address.'
 , i_title:2
 , title: function(val,tp,el)
 {
   return val;
 }
}});
//..Адрес доступа
PG.add_cpar( {nm:'dlmscl_daddr', obj:
{ ed:'e'//, tps:{ 'dlmscl_dev':''}
 , ln:'Access address'
 , hint:'The logical address of access through the server. More than 1.'
 , i_title:2
 , title: function(val,tp,el)
 {
   return val;
 }
}});
//..таймаут
PG.add_cpar( {nm:'dlmscl_to', obj:
 { ed:'e',ln:'Response timeout (ms)'//, tps:{ 'dlmscl_dev':'' }
 , hint:'Response timeout (ms).'
}});
//..Аутентификация
var __auth_VALs = {
    '0' : { sn:'none', ln: 'none' }
  , '1' : { sn:'low', ln: 'low' }
  , '2' : { sn:'high', ln: 'high' }
  , '3' : { sn:'md5', ln: 'high md5' }
  , '4' : { sn:'sha1', ln: 'high sha1' }
  , '5' : { sn:'GMAC', ln: 'high GMAC' }
  , '6' : { sn:'SHA256', ln: 'high SHA256' }
  , '7' : { sn:'ECDSA', ln: 'high ECDSA' }
  };
PG.add_cpar( {nm:'dlmscl_auth', obj:
{ ed:'l',ln:'Authentication'//, tps:{ 'dlmscl_dev':'0'}
 , hint:'Access authentication:\r\n none - authentication none\r\n low - low security level - password access\r\n high - high level of security with different algorithms.'
 , i_title:2
 , title: function(val,tp,el)
 {
   var c = this.VALs[val];
   val = c ? c.sn : __ERR+val;
   return val;
 }
  , VALs: __auth_VALs
}});
//..пароль
PG.add_cpar( {nm:'dlmscl_pass', obj:
{ ed:'e',ln:'Password'//, tps:{ 'dlmscl_dev':''}
 , hint:'Password'
}});
//..Уровень безопасности
var __sec_VALs = {
    '0' : { sn:'', ln: 'none' }
  , '1' : { sn:'A', ln: 'Authentication' }
  , '2' : { sn:'E', ln: 'Encryption' }
  , '3' : { sn:'AE', ln: 'Authentication and Encryption' }
  };
PG.add_cpar( {nm:'dlmscl_sec', obj:
{ ed:'l',ln:'Security'//, tps:{ 'dlmscl_dev':'0'}
 , hint:'Security:\r\n Authentication - authentication security is used\r\n Encryption - encryption security is used\r\n Authentication and Encryption - authentication and ancryption security are used.'
 , i_title:2
 , title: function(val,tp,el)
 {
   var c = this.VALs[val];
   val = c ? c.sn : __ERR+val;
   return val;
 }
 , VALs: __sec_VALs
}} );
//..Системный заголовок
PG.add_cpar( {nm:'dlmscl_syst', obj:
{ ed:'e',ln:'System Title'//, tps:{ 'dlmscl_dev':''}
 , hint:'System Title'
}});
//..Ключ аутентификации
PG.add_cpar( {nm:'dlmscl_akey', obj:
{ ed:'e',ln:'Authentication key'//, tps:{ 'dlmscl_dev':''}
 , hint:'Authentication key'
}});
//..Ключ блочного шифра
PG.add_cpar( {nm:'dlmscl_ekey', obj:
{ ed:'e',ln:'Block cipher key'//, tps:{ 'dlmscl_dev':''}
 , hint:'Block cipher key'
}});
//..Выделенный ключ
PG.add_cpar( {nm:'dlmscl_dkey', obj:
{ ed:'e',ln:'Dedicated key'//, tps:{ 'dlmscl_dev':''}
 , hint:'Dedicated key'
}});
//..Интерфейс
PG.add_cpar( {nm:'dlmscl_itp', obj:
{ ed:'l',ln:'Interface'//, tps:{ 'dlmscl_dev':'0'}
 , hint:'Interface:\r\n HDLC - serial port\r\n IPv4 - TCP/IP wrapper'
 , VALs: {
    '0' : { sn:'HDLC', ln: 'HDLC' }
  , '1' : { sn:'IPv4', ln: 'IPv4' }
  }
}} );
//..категория ПУ
PG.add_cpar( {nm:'dlmscl_mcat', obj:
{ ed:'l',ln:'Meter category'//, tps:{ 'dlmscl_dev':'C'}
 , hint:'Electricity meter category.\r\nUsed for OBIS filter in child components.'
 , i_title:2
 , title: function(val,tp,el)
 {
   var c = this.VALs[val];
   val = c ? c.sn : __ERR+val;
   return val;
 }
 , VALs: {
    '' : { sn:'', ln: '' }
  , 'A' : { sn:'A', ln: 'A' }
  , 'B' : { sn:'B', ln: 'B' }
  , 'C' : { sn:'C', ln: 'C' }
  , 'D' : { sn:'D', ln: 'D' }
  }
}} );
//..тип прибора
PG.add_cpar( {nm:'dlmscl_mtp', obj:
{ ed:'e',ln:'Meter type'//, tps:{ 'dlmscl_dev':''}
 , hint:'The meter type is coded with three characters of the Latin alphabet\r\n(RIM, SIT, MIR и др.)\r\nUsed to form a unique identifier.\r\n\r\nIf the counter does not return the correct type, or for debugging.'
 , i_title:2
 , title: function(val)
 {
   return val;
 }
}});
//..серийный номер
PG.add_cpar( {nm:'dlmscl_msn', obj:
{ ed:'e',ln:'Serial number'//, tps:{ 'dlmscl_dev':''}
 , hint:'Serial number.\r\nUsed to form a unique identifier.\r\n\r\nIf counter does not return serial number or for debugging.'
 , i_title:2
 , title: function(val)
 {
   return val;
 }
}});
//--------------------------------------------------------------
//Регистры..
PG.add_comp( {nm:'dlmscl_grregs', parents:['dlmscl_dev']
, obj:{
  nm:'Registers', add:true, st:''
, hint:'DLMS registers - current parameters.'
, im:'imIn'
, nmv:2
  , pnm:{ nm:'', dlmscl_rto:'60'}
}} );
//..период захвата
PG.add_cpar( {nm:'dlmscl_rto', obj:
{ ed:'e',ln:'Polling period (sec)'//, tps:{ 'dlmscl_grregs':'60'}
 , hint:'Period of polling registers in seconds.'
 , i_title:3
 , title: function(val,tp,el)
 {
   return val;
 }
}
} );
//--------------------------------------------------------------
//DLMS регистр..
PG.add_comp( {nm:'dlmscl_reg', parents:['dlmscl_grregs']
, obj:{
  nm:'DLMS register', add:true, st:''
, hint:'DLMS register - current parameter.'
, im:'imIn'
  , pnm:{ nm:'', plsig:'', dlmscl_plsig_robis:''}
}} );
//..obis
PG.add_cpar( {nm:'dlmscl_plsig_robis', obj:
{ ed:'q',ln:'OBIS-code'//, tps:{ dlmscl_reg:''}
 , hint:'OBIS-code'
 , i_title:2
 , incl:true //всегда включать в xml
 , title: titleOBIS
 , notsort:true
 , fvals: filrOBIS
 , VALs: OBIS
 , init : function( el, val )
 {
   editor_attr_update_vals_cl( el, this, val );
 }
}});
//--------------------------------------------------------------
//DLMS профиль..
PG.add_comp( {nm:'dlmscl_pg', parents:['dlmscl_dev']
, obj:{
  nm:'Profile', add:true, st:''
  , add_tps:[], hint:'Generic profile'
, im:'imIn'
  , pnm:{ nm:'', var_ok:'', dlmscl_pobis:'', dlmscl_pdeep:'128', dlmscl_pcapt:''}
}} );
/*
p_nm.tpsfn['dlmscl_pg'] = function( p )
{
  var pg = __PARs.dlmscl_pobis;
  var val = p.xref.dlmscl_pobis;
  if( val )
  {
    var c = pg.VALs[val];
    if( c )
    {
      if( val != c.sn )
        return '';
    }
  }
  val = p.xref.nm;
  if( val )
    val += ' ';
  val += __TPs[p.xref.tp].nm;
  return val;
} 
*/
//..obis
PG.add_cpar( {nm:'dlmscl_pobis', obj:
{ ed:'q',ln:'OBIS-код'//, tps:{ 'dlmscl_pg':''}
 , hint:'OBIS-код'
 , i_title:10
 , incl:true //всегда включать в xml
 , title: titleOBIS
 , notsort:true
 , fvals: filrOBIS
 , VALs: OBIS
 , init : function( el, val )
 {
   editor_attr_update_vals_cl( el, this, val );
 }
 }
} );
//..Глубина хранения
PG.add_cpar( {nm:'dlmscl_pdeep', obj:
{ ed:'q',ln:'Глубина хранения'//, tps:{ 'dlmscl_pg':'128'}
 , hint:'Глубина хранения в днях или часах (h в конце).'
 , i_title:3
 , title: function(val,tp,el)
 {
   return val;
 }
  , notsort:true
  , VALs: {
    '1h' : { sn:'1h', ln: 'час' }
  , '6h' : { sn:'6h', ln: '6 часов' }
  , '12h' : { sn:'12h', ln: '12 часов' }
  , '1' : { sn:'1', ln: 'день' }
  , '7' : { sn:'7', ln: '7 дней' }
  , '10' : { sn:'10', ln: '10 дней' }
  , '30' : { sn:'30', ln: '30 дней' }
  , '31' : { sn:'31', ln: '31 день' }
  , '90' : { sn:'90', ln: '90 дней' }
  , '128' : { sn:'128', ln: '128 дней' }
  , '183' : { sn:'0.5г', ln: 'полгода' }
  , '366' : { sn:'1г', ln: 'год' }
  , '731' : { sn:'2г', ln: '2 года' }
  , '1096' : { sn:'3г', ln: '3 года' }
  , '1280' : { sn:'3.5г', ln: '3.5 года' }
  }
}
} );
//..период захвата
PG.add_cpar( {nm:'dlmscl_pcapt', obj:
{ ed:'e',ln:'Период захвата (сек)'//, tps:{ 'dlmscl_pg':''}
 , hint:'Период вызова метода захвата (Capture) в секундах.\r\nДля профилей, которые автоматически не захватываются.\r\n(1.0.94.7.0.255 - профиль мгновенных параметров)\r\nЕсли не указан, то метод захват не вызывается.'
 , i_title:3
 , title: function(val,tp,el)
 {
   return val;
 }
}
} );
//--------------------------------------------------------------
//регистр профиля
PG.add_comp( {nm:'dlmscl_pnreg', parents:['dlmscl_pg']
, obj:{
  nm:'регистр профиля', add:true, st:''
, hint:'регистр профиля'
, im:'imIn'
  , pnm:{ nm:'', plsig:'', dlmscl_plsig_pnobis:''}
}} );
//..obis
PG.add_cpar( {nm:'dlmscl_plsig_pnobis', obj:
{ ed:'q',ln:'OBIS-код'//, tps:{ 'dlmscl_pnreg':''}
 , hint:'OBIS-код'
 , i_title:2
 , incl:true //всегда включать в xml
 , title: titleOBIS
 , init : function( el, val )
 {
   editor_attr_update_vals_cl( el, this, val );
 }
 , notsort:true
 , fvals: filrOBIS
 , VALs: OBIS
}});
//--------------------------------------------------------------
//}
//tm_dlmscl_add();
//function tm_dlmssvr_add()
//{
//var PG = new tm_plugin();
//--------------------------------------------------------------
//DLMS сервер..
PG.add_comp( {nm:'dlmssvr', parents:["port"]
, obj:{
  nm:'DLMS сервер', add:true, st:'', log:true
//  , add_tps:[]
, hint:'DLMS сервер'
  , pnm:{ nm:'', var_ok:'', tcpto:'0', log:'0', log_sz:'10', log_dd:'0', loglevel:'0'}
}} );
//--------------------------------------------------------------
//DLMS устройство сервер..
PG.add_comp( {nm:'dlmssvr_dev', parents:['dlmssvr']
, obj:{
  nm:'DLMS устройство', add:true, st:''//, log:true
, hint:'DLMS устройство сервер'
  , pnm:{ nm:'', var_ok:'', dlmssvr_paddr:'16', dlmssvr_to:'', dlmssvr_pw1:'', dlmssvr_pw2:'', dlmssvr_syst:'', dlmssvr_akey:'', dlmssvr_ekey:'', dlmssvr_kek:''}
}} );
//..физический адрес устройства
PG.add_cpar( {nm:'dlmssvr_paddr', obj:
{ ed:'e'//, tps:{ 'dlmssvr_dev':'16'}
//8.2.4. Сервер должен иметь физический адрес 16. Если несколько УСПД,
// должны использоваться их настраиваемые физические адреса.
 ,ln:'Физический адрес'
 , hint:'Физический адрес устройства'
 , i_title:2
 , title: function(val,tp,el)
 {
   return val;
 }
}});
//..таймаут
PG.add_cpar( {nm:'dlmssvr_to', obj:
 { ed:'e',ln:'Таймаут ответа (мс)'//, tps:{ 'dlmssvr_dev':'' }
 , hint:'Таймаут ответа (мс).'
}});
/*
//..Аутентификация
PG.add_cpar( {nm:'dlmssvr_auth', obj:
{ ed:'l',ln:'Аутентификация', tps:{ 'dlmssvr_dev':'0'}
 , hint:'Аутентификация доступа:\r\n none - отсутствие аутентификации\r\n low - низкий уровень безопасности – доступ с паролем\r\n high - высокий уровень безопасности с разными алгоритмами'
 , i_title:2
 , title: function(val,tp,el)
 {
   var c = this.VALs[val];
   val = c ? c.sn : __ERR+val;
   return val;
 }
  , VALs: __auth_VALs
}});
*/
//..пароль
PG.add_cpar( {nm:'dlmssvr_pw1', obj:
{ ed:'e',ln:'Password LLS'//, tps:{ 'dlmssvr_dev':''}
 , hint:'Password LLS'
}});
PG.add_cpar( {nm:'dlmssvr_pw2', obj:
{ ed:'e',ln:'Password HLS'//, tps:{ 'dlmssvr_dev':''}
 , hint:'Password HLS'
}});
/*
//..Уровень безопасности
PG.add_cpar( {nm:'dlmssvr_sec', obj:
{ ed:'l',ln:'Уровень безопасности', tps:{ 'dlmssvr_dev':'0'}
 , hint:'Уровень безопасности:\r\n Authentication - шифрование аутентификации\r\n Encryption - шифрование данных\r\n Authentication and Encryption - шифрование аутентификации и данных'
 , i_title:2
 , title: function(val,tp,el)
 {
   var c = this.VALs[val];
   val = c ? c.sn : __ERR+val;
   return val;
 }
 , VALs: __sec_VALs
}} );
*/
//..Системный заголовок
PG.add_cpar( {nm:'dlmssvr_syst', obj:
{ ed:'e',ln:'System Title'//, tps:{ 'dlmssvr_dev':''}
 , hint:'System Title'
}});
//..Ключ аутентификации
PG.add_cpar( {nm:'dlmssvr_akey', obj:
{ ed:'e',ln:'Authentication key'//, tps:{ 'dlmssvr_dev':''}
 , hint:'Authentication key'
}});
//..Ключ блочного шифра
PG.add_cpar( {nm:'dlmssvr_ekey', obj:
{ ed:'e',ln:'Block cipher key'//, tps:{ 'dlmssvr_dev':''}
 , hint:'Block cipher key'
}});
//..Мастер ключ
PG.add_cpar( {nm:'dlmssvr_kek', obj:
{ ed:'e',ln:'Master key'//, tps:{ 'dlmssvr_dev':''}
 , hint:'Master key (KEK)'
}});

//--------------------------------------------------------------
//DLMS мост..
PG.add_comp( {nm:'dlmsbr', parents:["port"]
, obj:{
  nm:'DLMS bridge', add:true, st:'', log:true
//  , add_tps:[]
, hint:'DLMS bridge'
  , pnm:{ nm:'', var_ok:'', tcpto:'0', log:'0', log_sz:'10', log_dd:'0', loglevel:'0'}
}} );

//--------------------------------------------------------------
//_LOC.locAdd( 'dlmscl' );//@locJSON
_LOC.locAdd( { pr:'loc', pf:'tmdlms', objs:{ COMPONENT:tm_comp_tps(), PARAM:tm_comp_pars(), OBIS:OBIS } } );//@locJSON
} //tm_dlms_add
//tm_dlmssvr_add();
tm_dlms_add();